/*********************************************************************
 *
 *                Microchip USB C18 Firmware - Mouse Demo
 *
 *********************************************************************
 * FileName:        user_mouse.c
 * Dependencies:    See INCLUDES section below
 * Processor:       PIC18
 * Compiler:        C18 2.30.01+
 * Company:         Microchip Technology, Inc.
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the CompanyE for its PICmicro Microcontroller is intended and
 * supplied to you, the Companys customer, for use solely and
 * exclusively on Microchip PICmicro Microcontroller products. The
 * software is owned by the Company and/or its supplier, and is
 * protected under applicable copyright laws. All rights are reserved.
 * Any use in violation of the foregoing restrictions may subject the
 * user to criminal sanctions under applicable laws, as well as to
 * civil liability for the breach of the terms and conditions of this
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS ISECONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Rawin Rojvanit       11/19/04    Original.
 ********************************************************************/

/** I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include "system/typedefs.h"


#include "io_cfg.h"             // I/O pin mapping
#include "user.h"
#include "delays.h"
#include "command.h"

#define VERSION 12

int PortImg=0;
int PicCLK =0;

/** V A R I A B L E S ********************************************************/
#pragma udata
char Buffer[64];
int BlockNumber=0;
int counter=0;
int j=0;

/** P R I V A T E  P R O T O T Y P E S ***************************************/
void setdefaultacd(void);
void getacd(int port, int config);
void delay(void);
void SetREG_W1 (int);
void SetREG_W2 (int);

/** D E C L A R A T I O N S **************************************************/
#pragma code

void UserInit(void)
{
    
    /* Init GPIO */
   
	TRISA = 0xFF;	// all inputs 
	PORTA = 0xFF;
 
	TRISB = 0x00; 	// all outputs
	PORTB = 0xFF;
	
	TRISC = 0xFF;	// all inputs
	PORTC = 0xFF;

	TRISD = 0x00;	// all outputs
	PORTD = 0x00;

	TRISE = 0xFF;	// all control at 1 expect AN5 RE0
	PORTE = 0xFF;
	 
}

//end UserInit



void setdefaultacd(void)
{
		/* 12 TAD FOSC/32 */
		ADCON2=42;
		/* AN0-15, VREF */
		ADCON1 = 0b00001011;
		/* Turn on the ADC */
		/* 12 TAD FOSC/32 */
		ADCON2=42;
		/* AN0-15, VREF */
		ADCON1 = 0b00001011;
		/* Turn on the ADC */
		ADCON0bits.ADON = 1;		ADCON0bits.ADON = 1;
		ADCON0bits.CHS3 = 0;
		ADCON0bits.CHS2 = 0;
}

void getacd(int port, int config)
{
	
		/* 12 TAD FOSC/32 */
		ADCON2=42;
		/* AN0-15, VREF */
		ADCON1 = 0b00001011;
		/* Turn on the ADC */
		ADCON0bits.ADON = 1;
//if (config) setdefaultacd();
// FOSC/32 clock select
/*	switch (port) {
		case 0 : {ADCON0bits.CHS1=0;ADCON0bits.CHS0=0;}   break;
		case 1 : {ADCON0bits.CHS1=0;ADCON0bits.CHS0=1;}   break;
		case 2 : {ADCON0bits.CHS1=1;ADCON0bits.CHS0=0;}   break;
		case 3 : {ADCON0bits.CHS1=1;ADCON0bits.CHS0=1;}   break;
	}
*/
	ADCON0bits.GO = 1;
	while (ADCON0bits.GO);
}


/******************************************************************************
 * Function:        void ProcessIO(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is a place holder for other user routines.
 *                  It is a mixture of both USB and non-USB tasks.
 *
 * Note:            None
 *****************************************************************************/
void ProcessIO(void)
{   


}//end ProcessIO

void delay()
{
 static word delay_count;
 
        delay_count = 1800U;                // Set RESUME line for 1-13 ms
        do
        {
            delay_count--;
        }while(delay_count);        
}   
void SetREG_W1 (int data)
{
	TRISB = 0;
	PORTB=data;			// bus = data
	PORTDbits.RD2 =0;
	delay();     
	PORTDbits.RD2 =1;	// pulse REG_W1
	delay();     
	PORTDbits.RD2 =0;
	TRISB = 0xFF; 	// bus input mode
}	
void SetREG_W2 (int data)
{
	TRISB = 0;
	PORTB=data;			// bus = data
	PORTAbits.RA0 =0;
	delay();     
	PORTAbits.RA0 =1;	// pulse REG_W2
	delay();     
	PORTAbits.RA0 =0;
	TRISB = 0xFF; 	// bus input mode
}	






/** EOF user_mouse.c *********************************************************/
